#include<bits/stdc++.h>
using namespace std;
vector<int>g[100010];
int ans[100010],g2[100000];
int n,m,r=1;
void dfs(int u){
    for(int i=0;i<g[u].size();i++)dfs(g[u][i]);
    for(int i=0;i<g[u].size();i++)ans[u]+=ans[g[u][i]]+1;
    return;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n;
    for(int i=0;i<n-1;i++){
        int u,v;
        cin>>u>>v;
        g[u].push_back(v);
        g2[v]=u;
    }
    while(g2[r]!=0)r=g2[r];
    dfs(r);
    cin>>m;
    for(int i=0;i<m;i++){
        int u;
        cin>>u;
        cout<<ans[u]<<"\n";
    }
}
